local leaveTimer = 0
local willLeave = false

addHook("TouchSpecial",function(special,toucher)
	--Activate a past warp if...
	if special.type == MT_PASTSIGN --The touched object is a Past sign
	and special.timeTravelee == nil --The sign doesn't have an assigned traveler yet
	and special.state != S_TRAVELSIGN_PAST2 --The sign isn't spinning
	and special.state != S_TRAVELSIGN_PAST3 --The sign hasn't been used already
	and toucher.health > 0 --The traveller is alive
		if toucher.traveling == true then
			return true
		else
			toucher.traveling = true
		end
		if toucher.timeTraveled == nil then
			toucher.timeTraveled = 1
		end
		special.state = S_TRAVELSIGN_PAST2
		special.timeTravelee = toucher
		leaveTimer = TICRATE*7
		willLeave = true
		S_StartSound(special,659)
		return true
	end
	--Activate a future warp if...
	if special.type == MT_FUTURESIGN --The touched object is a Past sign
	and special.timeTravelee == nil --The sign doesn't have an assigned traveler yet
	and special.state != S_TRAVELSIGN_FUTURE2 --The sign isn't spinning
	and special.state != S_TRAVELSIGN_FUTURE3 --The sign hasn't been used already
	and toucher.health > 0 --The traveller is alive
		if toucher.traveling == true then
			return true
		else
			toucher.traveling = true
		end
		if toucher.timeTraveled == nil then
			toucher.timeTraveled = 2
		end
		special.state = S_TRAVELSIGN_FUTURE2
		special.timeTravelee = toucher
		leaveTimer = TICRATE*7
		willLeave = true
		S_StartSound(special,658)
		return true
	end
	if special.type == MT_PASTSIGN
	or special.type == MT_FUTURESIGN
		return true --So the signs don't vanish when you touch them
	end
end)

addHook("MobjSpawn",function(mo)
	if (mo.type == MT_PASTSIGN or mo.type == MT_FUTURESIGN)
	and multiplayer
		P_RemoveMobj(mo) --The signs require a map change and are therefore not network-safe
	else --I mean, if ONE player used a past sign, EVERYONE would go to the past.
		if mo.timeTravelee == nil then
			mo.timeTravelee = nil --Init
		end
	end
end)

addHook("ThinkFrame", function()
	for player in players.iterate do
		if player.mo.traveling == true then
			if player.mo.timeTraveled == 1 then --I like to imagine these as polarizations.
				player.mo.colorized = true
				player.mo.color = SKINCOLOR_CYAN
			elseif player.mo.timeTraveled == 2 then
				player.mo.colorized = true
				player.mo.color = SKINCOLOR_RED
			end
			player.oldx = player.mo.x
			player.oldy = player.mo.y
			player.oldz = player.mo.z
			player.oldangle = player.mo.angle
			player.mo.frame = $|FF_FULLBRIGHT
			if player.speed > FRACUNIT*25 then
				local thokky = P_SpawnMobjFromMobj(player.mo,0,0,0,MT_THOK)
				thokky.color = player.mo.color
				thokky.frame = A|FF_FULLBRIGHT
			end
		else
			player.oldx = nil
			player.oldy = nil
			player.oldz = nil
			player.oldangle = nil
		end
	end
	if leaveTimer > 0 then
		leaveTimer = $ - 1
	else
		if willLeave == true then
			willLeave = false
			for player in players.iterate do
				if player.speed > FRACUNIT*25 then
					if player.mo.timeTraveled == 1 then
						G_ExitLevel(tonumber(mapheaderinfo[gamemap].pastmap),2)
					elseif player.mo.timeTraveled == 2 then
						G_ExitLevel(tonumber(mapheaderinfo[gamemap].futuremap),2)
					end
				else
					player.mo.traveling = nil
					player.mo.timeTraveled = nil
					player.mo.colorized = false
					player.mo.color = player.skincolor
				end
			end
		end
	end
end)

addHook("PlayerSpawn", function(player)
	if player.oldx
	and player.oldy
	and player.oldz
		P_TeleportMove(player.mo,player.oldx,player.oldy,player.oldz)
		player.mo.angle = player.oldangle
		player.mo.oldx = nil
		player.mo.oldy = nil
		player.mo.oldz = nil
		player.oldangle = nil
	end
end)